# mypy-boto3-migrationhub-config

[![PyPI - mypy-boto3-migrationhub-config](https://img.shields.io/pypi/v/mypy-boto3-migrationhub-config.svg?color=blue)](https://pypi.org/project/mypy-boto3-migrationhub-config)
[![PyPI - Python Version](https://img.shields.io/pypi/pyversions/mypy-boto3-migrationhub-config.svg?color=blue)](https://pypi.org/project/mypy-boto3-migrationhub-config)
[![Docs](https://img.shields.io/readthedocs/mypy-boto3-builder.svg?color=blue)](https://mypy-boto3-builder.readthedocs.io/)
[![PyPI - Downloads](https://img.shields.io/pypi/dw/mypy-boto3-migrationhub-config?color=blue)](https://pypistats.org/packages/mypy-boto3-migrationhub-config)

![boto3.typed](https://github.com/vemel/mypy_boto3_builder/raw/master/logo.png)

Type annotations for
[boto3.MigrationHubConfig 1.17.66](https://boto3.amazonaws.com/v1/documentation/api/1.17.66/reference/services/migrationhub-config.html#MigrationHubConfig)
service compatible with [VSCode](https://code.visualstudio.com/),
[PyCharm](https://www.jetbrains.com/pycharm/),
[Emacs](https://www.gnu.org/software/emacs/),
[Sublime Text](https://www.sublimetext.com/),
[mypy](https://github.com/python/mypy),
[pyright](https://github.com/microsoft/pyright) and other tools.

Generated by
[mypy-boto3-buider 4.10.0](https://github.com/vemel/mypy_boto3_builder).

More information can be found on
[boto3-stubs](https://pypi.org/project/boto3-stubs/) page and in
[mypy-boto3-migrationhub-config docs](https://github.com/vemel/mypy_boto3_builder/service_docs/mypy_boto3_migrationhub_config/README.md)

See how it helps to find and fix potential bugs:

![boto3-stubs demo](https://github.com/vemel/mypy_boto3_builder/raw/master/demo.gif)

- [mypy-boto3-migrationhub-config](#mypy-boto3-migrationhub-config)
  - [How to install](#how-to-install)
  - [Usage](#usage)
    - [VSCode](#vscode)
    - [PyCharm](#pycharm)
    - [Other IDEs](#other-ides)
    - [mypy](#mypy)
    - [pyright](#pyright)
  - [Explicit type annotations](#explicit-type-annotations)
    - [Client annotations](#client-annotations)
    - [Literals](#literals)
    - [Typed dictionaries](#typed-dictionaries)

## How to install

Install `boto3-stubs` for `MigrationHubConfig` service.

```bash
python -m pip install boto3-stubs[migrationhub-config]
```

## Usage

### VSCode

- Install
  [Python extension](https://marketplace.visualstudio.com/items?itemName=ms-python.python)
- Install
  [Pylance extension](https://marketplace.visualstudio.com/items?itemName=ms-python.vscode-pylance)
- Set `Pylance` as your Python Language Server
- Install `boto-stubs[migrationhub-config]` in your environment:
  `python -m pip install 'boto3-stubs[migrationhub-config]'`

Both type checking and auto-complete should work for `MigrationHubConfig`
service. No explicit type annotations required, write your `boto3` code as
usual.

### PyCharm

- Install `boto-stubs[migrationhub-config]` in your environment:
  `python -m pip install 'boto3-stubs[migrationhub-config]'`

Both type checking and auto-complete should work for `MigrationHubConfig`
service. No explicit type annotations required, write your `boto3` code as
usual. Auto-complete can be slow on big projects or if you have a lot of
installed `boto3-stubs` submodules.

### Other IDEs

Not tested, but as long as your IDE support `mypy` or `pyright`, everything
should work.

### mypy

- Install `mypy`: `python -m pip install mypy`
- Install `boto-stubs[migrationhub-config]` in your environment:
  `python -m pip install 'boto3-stubs[migrationhub-config]'`
- Run `mypy` as usual

Type checking should work for `MigrationHubConfig` service. No explicit type
annotations required, write your `boto3` code as usual.

### pyright

- Install `pyright`: `yarn global add pyright`
- Install `boto-stubs[migrationhub-config]` in your environment:
  `python -m pip install 'boto3-stubs[migrationhub-config]'`
- Optionally, you can install `boto3-stubs` to `typings` folder.

Type checking should work for `MigrationHubConfig` service. No explicit type
annotations required, write your `boto3` code as usual.

## Explicit type annotations

### Client annotations

`MigrationHubConfigClient` provides annotations for
`boto3.client("migrationhub-config")`.

```python
import boto3

from mypy_boto3_migrationhub_config import MigrationHubConfigClient

client: MigrationHubConfigClient = boto3.client("migrationhub-config")

# now client usage is checked by mypy and IDE should provide code auto-complete

# works for session as well
session = boto3.session.Session(region="us-west-1")
session_client: MigrationHubConfigClient = session.client("migrationhub-config")
```

### Literals

`mypy_boto3_migrationhub_config.literals` module contains literals extracted
from shapes that can be used in user code for type checking.

```python
from mypy_boto3_migrationhub_config.literals import (
    TargetType,
)

def check_value(value: TargetType) -> bool:
    ...
```

### Typed dictionaries

`mypy_boto3_migrationhub_config.type_defs` module contains structures and
shapes assembled to typed dictionaries for additional type checking.

```python
from mypy_boto3_migrationhub_config.type_defs import (
    CreateHomeRegionControlResultTypeDef,
    DescribeHomeRegionControlsResultTypeDef,
    GetHomeRegionResultTypeDef,
    HomeRegionControlTypeDef,
    TargetTypeDef,
)

def get_structure() -> CreateHomeRegionControlResultTypeDef:
    return {
      ...
    }
```
